<?php
/*
    GeoFilter - Prevents Fraud using geo web services
    Copyright (C) 2010-2012 WHMCS Addon

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
if (!defined("WHMCS"))
	die("This file cannot be accessed directly");


function geofilter_config() {
    $configarray = array(
    "name" => "GeoFilter Anti-Fraud",
    "version" => "1.4",
    "author" => "<a href='http://whmcsaddon.com'>WHMCS Addon</a>",
    "language" => "english",
    "fields" => array(
        "secret" => array ("FriendlyName" => "Secret Key", "Type" => "text", "Size" => "25", "Description" => "OAuth Secret Key"),
        "public" => array ("FriendlyName" => "Consumer Key", "Type" => "text", "Size" => "25", "Description" => "OAuth Consumer Key"),
        "license" => array ("FriendlyName" => "License", "Type" => "text", "Size" => "25", "Description" => "GeoFilter License Key"),
        "allowedCountry" => array ("FriendlyName" => "Country Whitelist", "Type" => "text", "Size" => "25", "Description" => "Only allow certain countries through by default.<br /><small>Comma Separated Country Codes. E.g. CA,US,GB</small>"),
        "disabledCountry" => array ("FriendlyName" => "Country Blacklist", "Type" => "text", "Size" => "25", "Description" => "Prevent certain countries from getting through.<br /><small>Comma Separated Country Codes. E.g. CA,US,GB</small>")
    ));
    return $configarray;
}

function geofilter_activate() {
	global $customadminpath;
	mysql_query("ALTER TABLE `tblclients` ADD `validaddress` INT NOT NULL ;");
	mysql_query("ALTER TABLE `tblorders` ADD `fraudaddress` TEXT NOT NULL ;");
	
	# 1.1 Revision
	mysql_query("ALTER TABLE `tblclients` ADD `lat` DECIMAL(18,10) NOT NULL ;");
	mysql_query("ALTER TABLE `tblclients` ADD `lng` DECIMAL(18,10) NOT NULL ;");
	# End Revision
	
	$configfile = file_get_contents("../configuration.php");
	if ($configfile) {
		$carray = array();
		$carray = explode("\n", $configfile);
		$found = false;
		foreach ($carray as &$v) {
			if ("require_once(\"includes/geochecker.php\");" == trim($v)) {
				$found = true;
				break;	
			}
			
			if ("?>" == trim($v)) {
				$v = "require_once(\"includes/geochecker.php\");\n?>";
			}
		}
		
		if (!$found) {
			$configfile = implode("\n", $carray);
			$result = file_put_contents("../configuration.php", $configfile);
		}
	}
	
	// Adds specialized admin functions to client summary
	$adminpath = $customadminpath;
	if (!$adminpath) $adminpath = "admin";
	$adminpathtemplate = ROOTDIR."/".$adminpath."/templates/";
	
	if ($dh = opendir($adminpathtemplate)) {
		while (($file = readdir($dh)) !== false) {
			if (is_dir($adminpathtemplate.$file) && "." != $file && ".." != $file) {
				$content = file_get_contents($adminpathtemplate.$file."/clientssummary.tpl");
				$content = str_replace('<li><a href="verify.php?id={$clientsdetails.id}"><img src="images/icons/shield_add.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.verify}</a>
<li><a href="verify.php?id={$clientsdetails.id}&watch=true"><img src="images/icons/shield_go.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.watch}</a>
<li><a href="verify.php?id={$clientsdetails.id}&unverify=true"><img src="images/icons/shield_delete.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.unverify}</a>
<li><a href="http://maps.google.com/maps?q={$clientsdetails.address1}, {if $clientsdetails.address2}{$clientsdetails.address2}, {/if}{$clientsdetails.city}, {$clientsdetails.state}, {$clientsdetails.postcode}, {$clientsdetails.countrylong}" target="_blank"><img src="images/icons/map.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.googlemap}</a>', "", $content);
				$content = str_replace('{$_ADMINLANG.clientsummary.loginasclient}</a>', '{$_ADMINLANG.clientsummary.loginasclient}</a>
<li><a href="verify.php?id={$clientsdetails.id}"><img src="images/icons/shield_add.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.verify}</a>
<li><a href="verify.php?id={$clientsdetails.id}&watch=true"><img src="images/icons/shield_go.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.watch}</a>
<li><a href="verify.php?id={$clientsdetails.id}&unverify=true"><img src="images/icons/shield_delete.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.unverify}</a>
<li><a href="http://maps.google.com/maps?q={$clientsdetails.address1}, {if $clientsdetails.address2}{$clientsdetails.address2}, {/if}{$clientsdetails.city}, {$clientsdetails.state}, {$clientsdetails.postcode}, {$clientsdetails.countrylong}" target="_blank"><img src="images/icons/map.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.googlemap}</a>', $content);
				$result = file_put_contents($adminpathtemplate.$file."/clientssummary.tpl", $content);
			}
		}
		closedir($dh);
	}
	
	// Adds languages
	$adminpathlang = ROOTDIR."/".$adminpath."/lang/";
	if ($dh = opendir($adminpathlang)) {
		while (($file = readdir($dh)) !== false) {
			if ("." != $file && ".." != $file) {
				$content = file_get_contents($adminpathlang.$file);
				
				$explosion = explode("\$_ADMINLANG['clientsummary']['verify']", $content);
				if (1 == count($explosion)) {
					$content = str_replace("?>", "\$_ADMINLANG['clientsummary']['verify'] = 'Verify Client';
\$_ADMINLANG['clientsummary']['watch'] = 'Watch Client';
\$_ADMINLANG['clientsummary']['unverify'] = 'Unverify Client';
\$_ADMINLANG['clientsummary']['googlemap'] = 'Google Map';

?>", $content);
					$result = file_put_contents($adminpathlang.$file, $content);
				}
			}
		}
		closedir($dh);
	}
}

function geofilter_deactivate() {
	global $customadminpath;
	
	$configfile = file_get_contents("../configuration.php");
	if ($configfile) {
		$carray = array();
		$carray = explode("\n", $configfile);
		$found = false;
		foreach ($carray as $k=>&$v) {
			if ("require_once(\"includes/geochecker.php\");" == trim($v)) {
				$v = "";
				unset($carray[$k]);
				break;	
			}
		}
		$configfile = implode("\n", $carray);
		$result = file_put_contents("../configuration.php", $configfile);
		
		// Removes specialized admin functions to client summary
		$adminpath = $customadminpath;
		if (!$adminpath) $adminpath = "admin";
		$adminpathtemplate = ROOTDIR."/".$adminpath."/templates/";
		
		if ($dh = opendir($adminpathtemplate)) {
			while (($file = readdir($dh)) !== false) {
				if (is_dir($adminpathtemplate.$file) && "." != $file && ".." != $file) {
					$content = file_get_contents($adminpathtemplate.$file."/clientssummary.tpl");
					$content = str_replace('<li><a href="verify.php?id={$clientsdetails.id}"><img src="images/icons/shield_add.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.verify}</a>
<li><a href="verify.php?id={$clientsdetails.id}&watch=true"><img src="images/icons/shield_go.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.watch}</a>
<li><a href="verify.php?id={$clientsdetails.id}&unverify=true"><img src="images/icons/shield_delete.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.unverify}</a>
<li><a href="http://maps.google.com/maps?q={$clientsdetails.address1}, {if $clientsdetails.address2}{$clientsdetails.address2}, {/if}{$clientsdetails.city}, {$clientsdetails.state}, {$clientsdetails.postcode}, {$clientsdetails.countrylong}" target="_blank"><img src="images/icons/map.png" border="0" align="absmiddle" /> {$_ADMINLANG.clientsummary.googlemap}</a>', "", $content);
					$result = file_put_contents($adminpathtemplate.$file."/clientssummary.tpl", $content);
				}
			}
			closedir($dh);
		}
	} else {
		
	}
}

function geofilter_upgrade($vars) {

    $version = $vars['version'];
	
	if ($version < 1.1) {
		# 1.1 Revision
		mysql_query("ALTER TABLE `tblclients` ADD `lat` DECIMAL(18,10) NOT NULL ;");
		mysql_query("ALTER TABLE `tblclients` ADD `lng` DECIMAL(18,10) NOT NULL ;");
		# End Revision	
	}
	
}

function geofilter_output($vars) {
	$result = mysql_query("SELECT `lng`, `lat`, `id` FROM `tblclients` WHERE `lng`!=0 AND `lat`!=0 AND `id`>=RAND() * (SELECT MAX(`id`) FROM `tblclients` WHERE `lng`!=0 AND `lat`!=0) LIMIT 25");
	echo '<script type="text/javascript"
    src="https://maps-api-ssl.google.com/maps/api/js?sensor=true">
</script>
<script type="text/javascript">
  function initialize() {
    var latlng = new google.maps.LatLng(0,0);
    var myOptions = {
      zoom: 1,
      center: latlng,
      mapTypeId: google.maps.MapTypeId.ROADMAP
    };
    var map = new google.maps.Map(document.getElementById("map_canvas"),
        myOptions);
	var markers = [';


while ($row = mysql_fetch_array($result)) {
	echo '
	{ lat: '.$row["lat"].', lng: '.$row["lng"].', name: "Client '.$row["id"].'" },';
}
	echo '
	];
	  // Create the markers
    for (index in markers) addMarker(markers[index]);
    function addMarker(data) {
	  var marker = new google.maps.Marker({
	  position: new google.maps.LatLng(data.lat, data.lng),
	  map: map,
			title: data.name
	  });

    }

  }

  $(document).ready(function () {
	  initialize();
  });

</script>

<div id="map_canvas" style="width:500px; height:300px; float:left; margin-right: 5px;"></div><div style="height: 300px;">This Google Map shows 25 of your verified clients locations throughout the world.<br /><br />Since GeoFilter uses the Google Maps API to verify your clients addressing information this map was placed here to comply with the Google Maps API terms of service.</div>';

	echo '<br />Thanks for purchasing GeoFilter!
	<h3>What Next?</h3>
	Have you configured the addons settings? This is very important for the addon to work correctly.<br /><br />
	This addon requires an OAuth key! This allows the addon to interact with your sites API in a secure passwordless transaction.<br />
	<span style="font-size: 11px; font-style: italic;">Please make sure your OAuth key has access to the following API functions: pendingorder, acceptorder, modulecreate, fraudorder</span>
	<br />
	<h3>Setting up an OAuth Key</h3>
	<ul>
	<li style="list-style-type:circle;">After uploading and activating the OAuth addon, you should now be able to go to the OAuth manager by Addons -> Oauth.
	<li style="list-style-type:circle;">Click on "Create OAuth Key"
	<li style="list-style-type:circle;">Name the OAuth Key something like "GeoFilter" for your future reference.
	<li style="list-style-type:circle;">You can also deny all the unused API commands from running using this key (refer to list above of required API functions).
	<li style="list-style-type:circle;">Your key should now be generated copy and paste your consumer key and secret key into the GeoFilter settings.
	</ul>
	<h3>Review it!</h3>
	We spend a lot of time and thought creating great addons for you. We\'d love to hear what you think about it and how we can improve. Please fill in the form below:
	<form method="post" action="addonmodules.php?module=geofilter">
		<table>
		<tr>
			<td>Your Name:</td><td><input type="text" name="name" style="width: 400px;"></td>
		</tr><tr>
			<td>Your Website:</td><td><input type="text" name="website" style="width: 400px;"></td>
		</tr><tr>
			<td valign="top">Review:</td><td><textarea name="review" style="width: 400px; height: 75px;"></textarea></td>
		</tr>
		</table>
	</form>
	';

}

function geofilter_sidebar($vars) {

    $modulelink = $vars['modulelink'];
    $version = $vars['version'];
    $option1 = $vars['license'];
    $option2 = $vars['option2'];
    $option3 = $vars['option3'];
    $option4 = $vars['option4'];
    $option5 = $vars['option5'];
    $LANG = $vars['_lang'];

    $sidebar = '<span class="header"><img src="images/icons/shield.png" class="absmiddle" width="16" height="16" /> GeoFilter</span>

	<span style="margin-bottom: 10px; border-top: 1px solid #EBEBEB; border-bottom: 1px solid #EBEBEB; display: block;">
	Version: '.$version.'<br />
	';
	
	$appstats = geofilter_appstats($vars);
	
	$sidebar .= 'Support: <a href="https://whmcsaddon.com/myaccount/link.php?id=4">WHMCS Addon</a>';
	
	if ($appstats["update"]) {
		$sidebar .= '<br /><span class="textred">Version '.$appstats["update"].' is now available!</span><br />';
	}
	
	$sidebar .= '</span>';
	
    return $sidebar;

}

/*
	In accordance with our terms of service this function is required to receive support through WHMCS Addon
*/
function geofilter_appstats($vars) {
	$postfields = array (
		"version" => $vars["version"],
		"license" => $vars["license"],
		"validdomain" => $_SERVER["SERVER_NAME"],
		"validip" => $_SERVER["SERVER_ADDR"],
	);
	
	$ch = curl_init("https://whmcsaddon.com/myaccount/modules/servers/licensing/stats.php");
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	$data = curl_exec($ch);
	curl_close($ch);
	return json_decode($data, true);
}

?>