<?php
/*
    GeoFilter - Prevents Fraud using geo web services
    Copyright (C) 2010-2012 WHMCS Addon

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

function google_account_validator_editDetails($vars) {
    global $errormessage, $_LANG;
	include "includes/geochecker.php";
	$geo = new geochecker();
	if ($vars["save"]) {
		$addressFormat = $geo->formatGoogleAddress($vars);
				
		$clientdetails = array();
		$clientdetails = $vars;
		foreach ($clientdetails as &$cd) {
			$cd = strtoupper($geo->normalizestringdata($cd));	
		}
		
		# 1.1 Revision :: Added user variable
		$clientdetails["id"] = $_SESSION["uid"];
		
		// Only allow 10 attempts per a user. Otherwise it will always display the address validation error.
		// The reason for this is that Google only allows a certain number of requests per a day....
		if ($_SESSION["googleaddressverification"] < 11 && $addressFormat) {
			$result = $geo->googleGeocode($addressFormat, $clientdetails);
			
			if ($result) {
				$_SESSION["googleaddressverification"] = 0;
				$geo->approveClient($_SESSION["uid"], true);
			} else {
				$_SESSION["googleaddressverification"]++;
				$errormessage .= "<li>".$_LANG["googleaddressverification"]."</li>";
			}
	   } else {
			$errormessage .= "<li>".$_LANG["googleaddressverification"]."</li>";
	   }
	}
}

add_hook("ClientDetailsValidation",1,"google_account_validator_editDetails");

?>