<?php
/*
    GeoFilter - Prevents Fraud using geo web services
    Copyright (C) 2010-2012 WHMCS Addon

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if(class_exists('geochecker') != true) {
	class geochecker {
		
		private $settings = array();
		
		function __construct() {
			$result = mysql_query("SELECT `setting`, `value` FROM `tbladdonmodules` WHERE `module`='geofilter'");
			while($row = mysql_fetch_array($result)) {
				$this->settings[$row["setting"]] = $row["value"];
			}
			$result = mysql_query("SELECT `setting`, `value` FROM `tblconfiguration` WHERE `setting`='SystemURL' OR `setting`='SystemSSLURL' OR `setting`='geofilterlocal'");
			while($row = mysql_fetch_array($result)) {
				$this->settings[$row["setting"]] = $row["value"];
			}
		}
		
		function geochecker() { $this->__construct(); }
		
		function normalizestringdata($string) {
			$table = array(
				'Š'=>'S', 'š'=>'s', '?'=>'Dj', 'đ'=>'dj', 'Ž'=>'Z', 'ž'=>'z', 'Č'=>'C', '?'=>'c', 'Ć'=>'C', 'ć'=>'c',
				'À'=>'A', '?'=>'A', 'Â'=>'A', 'Ã'=>'A', 'Ä'=>'A', 'Å'=>'A', 'Æ'=>'A', 'Ç'=>'C', 'È'=>'E', 'É'=>'E',
				'Ê'=>'E', 'Ë'=>'E', 'Ì'=>'I', '?'=>'I', 'Î'=>'I', '?'=>'I', 'Ñ'=>'N', 'Ò'=>'O', 'Ó'=>'O', 'Ô'=>'O',
				'Õ'=>'O', 'Ö'=>'O', 'Ø'=>'O', 'Ù'=>'U', 'Ú'=>'U', 'Û'=>'U', 'Ü'=>'U', '?'=>'Y', 'Þ'=>'B', 'ß'=>'Ss',
				'à'=>'a', 'á'=>'a', 'â'=>'a', 'ã'=>'a', 'ä'=>'a', 'å'=>'a', 'æ'=>'a', 'ç'=>'c', 'è'=>'e', 'é'=>'e',
				'ê'=>'e', 'ë'=>'e', 'ì'=>'i', 'í'=>'i', 'î'=>'i', 'ï'=>'i', 'ð'=>'o', 'ñ'=>'n', 'ò'=>'o', 'ó'=>'o',
				'ô'=>'o', 'õ'=>'o', 'ö'=>'o', 'ø'=>'o', 'ù'=>'u', 'ú'=>'u', 'û'=>'u', 'ý'=>'y', 'ý'=>'y', 'þ'=>'b',
				'ÿ'=>'y', 'Ŕ'=>'R', 'ŕ'=>'r',
			);
			return strtr($string, $table);
		}
                
                function setting($s) { return $this->settings[$s]; }
		
		function getUserFromOrder($orderid) {
			$result = mysql_query("SELECT `userid` FROM `tblorders` WHERE `id`='".(int)$orderid."' LIMIT 1");
			while ($row = mysql_fetch_array($result)) {
				$theUser = $row["userid"];
			}
			return $theUser;
		}
		
		function getUserDetails($userid) {
			# 1.1 Revision :: added id selector
			$result = mysql_query("SELECT `id`, `address1`, `city`, `state`, `postcode`, `country`, `validaddress` FROM `tblclients` WHERE `id`='".(int)$userid."' LIMIT 1");
			while ($row = mysql_fetch_array($result)) {	
				$clientdetails = array();
				$clientdetails = $row;
				foreach ($clientdetails as &$cd) {
					$cd = strtoupper($this->normalizestringdata($cd));	
				}
			}
			
			return $clientdetails;
		}
		
		function formatGoogleAddress($clientdetails) {
			if ($clientdetails["address1"]) {
				$addressFormat = str_replace(" ", "+", $clientdetails["address1"]);
				if ($clientdetails["city"]) $addressFormat .= ",+".str_replace(" ", "+", $clientdetails["city"]);
				if ($clientdetails["state"]) $addressFormat .= ",+".str_replace(" ", "+", $clientdetails["state"]);
				if ($clientdetails["postcode"]) $addressFormat .= ",+".str_replace(" ", "+", $clientdetails["postcode"]);
				if ($clientdetails["country"]) $addressFormat .= ",+".str_replace(" ", "+", $clientdetails["country"]);
				return $addressFormat;
			}
			return false;
		}
		
		function googleGeocode($addressFormat, $clientdetails, $order=false) {
			$ch = curl_init("https://maps.googleapis.com/maps/api/geocode/json?sensor=true&address=".$addressFormat);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$output = curl_exec($ch);
			curl_close($ch);
			
			$googleResponse = json_decode($output, true);
			
			# 1.1 Revision :: Fixed $theUser variable.
			$theUser = (int)$clientdetails["id"];
			
			// Nice-ify google response
			$verified = false;
			
			for ($x=0;$x<count($googleResponse["results"]);$x++) {
				$googleNiceShort = array();
				$googleNiceLong = array();
				if ($googleResponse["results"][$x]["address_components"]) {
					# 1.1 Revision :: replaced 0 with $x
					foreach ($googleResponse["results"][$x]["address_components"] as $component) {
						$googleNiceShort[$component["types"][0]] = strtoupper($this->normalizestringdata($component["short_name"]));
						$googleNiceLong[$component["types"][0]] = strtoupper($this->normalizestringdata($component["long_name"]));
					}
				}
				
				# 1.3 Revision :: Added PO BOX detection and better support for UK addresses
				if ($clientdetails["validaddress"] == 1 || $googleResponse["status"] == "OK" && $this->compareAddress($googleResponse["results"][$x], $googleNiceShort, $googleNiceLong, $clientdetails)) {
					// Validated Client :)
					
					# 1.1 Revision :: added lat/lng saving for maps
					$lat = (float)$googleResponse["results"][$x]["geometry"]["location"]["lat"];
					$lng = (float)$googleResponse["results"][$x]["geometry"]["location"]["lng"];
					
					mysql_query("UPDATE `tblclients` SET `validaddress`=1, `lng`=".$lng.", `lat`=".$lat." WHERE `id`='".$theUser."'");
					
					$verified = true;
					break;
				} 
			}
			
			if ($verified) {
				$result = mysql_query("INSERT INTO `tblactivitylog` (`date`,`description`,`user`) VALUES (now(),'Client ID <a href=\'clientssummary.php?userid=".$theUser."\'>".$theUser."</a> Passed GeoFilter Validation','Client')");
				return true;
			} elseif ($googleResponse["status"] == "OVER_QUERY_LIMIT") {
				// Over Google API limit pass them through... suggested to run mail function to admin.
				foreach($row as $key => $val) {
					$message .= "\n".$key.': '.$val;
				}
				
				$result = mysql_query("INSERT INTO `tblactivitylog` (`date`,`description`,`user`) VALUES (now(),'Google Geocoding Over Limit','System')");
				return true;
			} else {
				// Terminate
				$result = mysql_query("INSERT INTO `tblactivitylog` (`date`,`description`,`user`) VALUES (now(),'Client ID <a href=\'clientssummary.php?userid=".$theUser."\'>".$theUser."</a> Failed GeoFilter Validation','Client')");
				mysql_query("UPDATE `tblclients` SET `validaddress`=0 WHERE `id`='".$theUser."'");
				if ($order) {
					$this->orderFraudLog($order, $output."\nhttp://maps.googleapis.com/maps/api/geocode/json?sensor=true&address=".$addressFormat);
				}
				return false;
			}
		}
		
		# 1.3 Addition :: Compare Addresses
		function compareAddress($googleResponse, $googleNiceShort, $googleNiceLong, $clientdetails) {
			$value = 0;
			if (in_array("street_address", $googleResponse["types"]) || in_array("postal_code", $googleResponse["types"]) || in_array("route", $googleResponse["types"]) ) $value++;
			if (in_array($clientdetails["country"], $googleNiceShort) || in_array($clientdetails["country"], $googleNiceLong)) $value++;
			if (in_array($clientdetails["state"],$googleNiceLong) || in_array($clientdetails["state"], $googleNiceShort)) $value++;
			if (in_array($clientdetails["city"], $googleNiceShort) || in_array($clientdetails["city"], $googleNiceLong)) $value++;
			
			// United Kingdom Addresses seem to have different return values then user input. Still valid.
			if (($clientdetails["country"] == "GB" || $clientdetails["country"] == "United Kingdom")) {
				//$value++;
				if (count($googleNiceLong) > 5) $value++;
			}
			
			// PO Box Addresses seem to return false so we use this fix.
			if ($this->pobox($clientdetails["address1"])) $value+=2;
                        
                        // Added Country White/Black Listing
                        if ($this->allowedCountry($clientdetails["country"])) {
                            $value += 1;
                        }
			
			if ($value >= 5) return true;
			else return false;
		}
		
		# 1.3 Addition :: PO Box Detection Function
		function pobox($addr) {
			$addr = strtolower($addr);
			$result = strpos($addr, 'pobox');
                        $result2 = strpos($addr, 'po box');
			if ($result === false && $result2 === false) return false;
			else return true;
		}
                
                # 1.4 Addition :: Allowed Countries and Block Countries
                function allowedCountry($country) {
                        $whitelist = explode(",", str_replace(" ", "", strtoupper($this->settings["allowedCountry"])));
                        $blacklist = explode(",", str_replace(" ", "", strtoupper($this->settings["disabledCountry"])));
                        $country = strtoupper($country);
                        
                        if (empty($this->settings["allowedCountry"]) && empty($this->settings["disabledCountry"])) return true;
                        
                        if (in_array($country, $whitelist) && !in_array($country, $blacklist)) return true;
                        else return false;
                }
		
		function orderFraudLog($orderid, $log="fraud") {
			$result = mysql_query("SELECT `fraudoutput`, `fraudmodule` FROM `tblorders` WHERE `id`='".(int)$orderid."' LIMIT 1");
			while ($row = mysql_fetch_array($result)) {
				if ($row["fraudmodule"] == "maxmind") {
					$maxmind = explode ("\n", $row["fraudoutput"]);
					$array = array();
					foreach ($maxmind as $v) {
						$mm = explode (' => ', $v);
						$array[$mm[0]] = $mm[1];
					}
					$array["explanation"] .= ". This users address was unable to be verified.";
					
					$string = "";
					foreach ($array as $k=>$v) {
						$string .= $k." => ".$v."\n";
					}
					
				}
			}
			
			mysql_query("UPDATE `tblorders` SET `fraudoutput`='".mysql_real_escape_string($string)."', `fraudaddress`='".mysql_real_escape_string($log)."' WHERE `id`='".(int)$orderid."'");
		}
		
		function approveClient($clientid, $self=false) {
			mysql_query("UPDATE `tblclients` SET `validaddress`=1 WHERE `id`='".(int)$clientid."'");
			return $this->activateClient($clientid, $self);
		}
		
		function watchClient($clientid) {
			mysql_query("UPDATE `tblclients` SET `validaddress`=0 WHERE `id`='".(int)$clientid."'");
			return $this->activateClient($clientid);
		}
		
		function unverifyClient($clientid) {
			$result = mysql_query("UPDATE `tblclients` SET `validaddress`=0 WHERE `id`='".(int)$clientid."'");
			return $result;
		}
		
		function activateClient($clientid, $self=false) {
			$paying = false;
			
			if ($self) {
				$result = mysql_query("SELECT `id`, `amount` FROM `tblorders` WHERE `userid`='".(int)$clientid."' AND `status`='Fraud' AND `fraudaddress`!=''");
			} else {
				$result = mysql_query("SELECT `id`, `amount` FROM `tblorders` WHERE `userid`='".(int)$clientid."' AND `status`='Fraud'");
			}
			while ($row = mysql_fetch_array($result)) {
				$oa1 = $this->oauth("pendingorder", array("orderid" => $row["id"]));
				if ($row["amount"] == 0) {
					// 1.4 Update for WHMCS 5
                                        $oa2 = $this->oauth("acceptorder", array("orderid" => $row["id"], "autosetup" => "true", "sendemail" => "true"));
					/*$result2 = mysql_query("SELECT `id` FROM `tblhosting` WHERE `userid`='".(int)$clientid."' AND `orderid`='".(int)$row["id"]."'");
					while ($row2 = mysql_fetch_array($result2)) {
						$oa3 = $this->oauth("modulecreate", array("accountid" => $row2["id"]));
					}*/
				} else
					$paying = true;
			}
			
			return $paying;
		}
		
		function oauth($action, $post) {
			$oauth_secret = $this->settings["secret"];
			// Define the data being posted to the server
			$postfields = array(
			'oauth_consumer_key' => $this->settings["public"],
			'oauth_nonce' => uniqid('', true),
			'oauth_timestamp' => time(),
			'oauth_version' => "1.0",
			'action' => $action,
			);
			
			foreach($post as $k=>$v) {
				$postfields[$k] = $v;	
			}
			// Create the OAuth token
			$postfields["oauth_token"] = sha1(base64_encode($postfields["oauth_nonce"].$postfields["oauth_timestamp"].$postfields["oauth_consumer_key"].$oauth_secret));
			
                        if ($this->settings["SystemSSLURL"])
				$base = $this->settings["SystemSSLURL"];
			else
				$base = $this->settings["SystemURL"];
			
			// CURL code to make request
			$ch = curl_init($base."/modules/addons/oauth/oauth_server.php");
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			$data = curl_exec($ch);
			curl_close($ch);
			return json_decode($data, true);
		}
	}
}

// Fraud Checks Orders
$currentpage = array();
$currentpage = explode( ".", basename($_SERVER["REQUEST_URI"]));
if ($currentpage[0] == "cart" && $_REQUEST["a"] == 'complete') {
	session_start();
	mysql_connect($db_host, $db_username, $db_password);
	mysql_select_db($db_name);
	
	$geo = new geochecker();
	
	$theUser = $geo->getUserFromOrder($_SESSION['orderdetails']['OrderID']);
	
	$clientdetails = array();
	$clientdetails = $geo->getUserDetails($theUser);
	$addressFormat = $geo->formatGoogleAddress($clientdetails);	
	$result = $geo->googleGeocode($addressFormat, $clientdetails, $_SESSION['orderdetails']['OrderID']);
	if (!$result) {
		// Terminate
		$geo->oauth("fraudorder", array("orderid" => $_SESSION['orderdetails']['OrderID']));
		header("location: fraud.php");
		exit();
		
	}
}

?>